#include<bits/stdc++.h>
using namespace std;

int n,a,b,dof[100005],q,mem[100005],r,res=0;
vector<int> t[100005];
queue<int> qh;

int fs(int w){
    res=0;
    qh.push(w);
    while(!(qh.empty())){
        int tek=qh.front();
        for(int i=0;i<t[tek].size();i++){
            qh.push(t[tek][i]);
        }
        res++;
        qh.pop();
    }
    res--;
    return res;
}

void pech(){
    cout<<endl;
    for(int i=1;i<n;i++){
        cout<<i<<" -> ";
        for(int j=0;j<t[i].size();j++){
            cout<<t[i][j]<<" ";
        }
        cout<<endl;
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cout.tie(NULL);

    cin>>n;
    for(int i=0;i<n-1;i++){
        cin>>a>>b;
        t[a].push_back(b);
    }
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>r;
        cout<<fs(r)<<endl;
    }
    //pech();

    return 0;
}


